package com.pj;

import cn.dev33.satoken.annotation.SaCheckPermission;
import cn.hutool.core.util.StrUtil;
import com.pj.current.satoken.StpUserUtil;
import com.pj.project.tb_manager.TbManager;
import com.pj.project.tb_manager.TbManagerService;
import com.pj.project4sp.SP;
import com.pj.utils.sg.AjaxJson;
import com.pj.utils.so.SoMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collector;
import java.util.stream.Collectors;


/**
 * Controller: tb_manager -- 防疫人员
 *
 * @author qzyReal
 */
@RestController
@RequestMapping("/TbAlarmPerson/")
public class TbPersonAlarmController {

    /**
     * 底层 Service 对象
     */
    @Autowired
    TbManagerService tbManagerService;

    /**
     * 增
     */
    @RequestMapping("add")
    @SaCheckPermission(TbManager.PERMISSION_ALARM_PERSON_ADD)
    public AjaxJson addAlarm(TbManager t) {
        t.setAlarm(1);
        tbManagerService.add(t);
        return AjaxJson.getSuccessData(t);
    }

    /**
     * 删
     */
    @RequestMapping("delete")
    @SaCheckPermission(TbManager.PERMISSION_ALARM_PERSON_DEL)
    public AjaxJson delete(Long id) {
        tbManagerService.delete(id);
        return AjaxJson.getSuccess();
    }



    /**
     * 改
     */
    @RequestMapping("update")
    @SaCheckPermission(TbManager.PERMISSION_ALARM_PERSON_EDIT)
    public AjaxJson update(TbManager t) {
        tbManagerService.update(t);
        return AjaxJson.getSuccess();
    }

    /**
     * 查 - 根据id
     */
    @RequestMapping("getById")
    public AjaxJson getById(Long id) {
        TbManager t = tbManagerService.getById(id);
        return AjaxJson.getSuccessData(t);
    }

    /**
     * 查集合 - 根据条件（参数为空时代表忽略指定条件）
     */
    @RequestMapping("getList")
    public AjaxJson getList() {
        SoMap so = SoMap.getRequestSoMap();
        so.put("alarm",1);
        if (!StpUserUtil.isAdmin()) {
            so.put("departmentId",StpUserUtil.getDeptId());
        }
        List<TbManager> list = tbManagerService.getList(so.startPage());
        return AjaxJson.getPageData(so.getDataCount(), list);
    }


}
