package com.pj.current.netty.command.handler.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.RandomUtil;
import cn.hutool.core.util.XmlUtil;
import cn.hutool.extra.spring.SpringUtil;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.pj.current.config.MyConfig;
import com.pj.current.netty.command.constants.CommandType;
import com.pj.current.netty.command.handler.IHandler;
import com.pj.current.netty.dto.OKMsg;
import com.pj.current.netty.dto.RequestPackageDTO;
import com.pj.current.task.TaskService;
import com.pj.project.tb_terminal.TbTerminal;
import com.pj.project.tb_terminal.TbTerminalService;
import com.pj.project.tb_terminal.task.FinishCommandTask;
import io.netty.channel.ChannelHandlerContext;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * 设备属性处理
 */
@Service
@Slf4j
public class TerminalOptionHandler implements IHandler {

    @Resource
    private TbTerminalService tbTerminalService;
    @Resource
    private MyConfig myConfig;
    @Resource
    TaskService taskService;

    @Override
    public CommandType commandType() {
        return CommandType.UPLOAD_TERMINAL_OPTION;
    }

    @Override
    public void handler(ChannelHandlerContext ctx, RequestPackageDTO packageDTO) {
        JSONObject params = JSONUtil.parseObj(packageDTO.getPayload().getParams());
        log.info("上传设备属性:{}",params.toJSONString(0));
        String sn = params.getStr("sn");
        Long userCount = params.getLong("UserCount");
        String ip = params.getStr("IPAddress");
        TbTerminal tbTerminal = tbTerminalService.findBySN(sn);
        tbTerminal.setPersonNum(userCount).setIpAddress(ip).setLastOnLine(DateUtil.now());
        tbTerminalService.updateById(tbTerminal);
        if (myConfig.getLimitUserCount()<=userCount) {

        }
        taskService.addTask(new FinishCommandTask(RandomUtil.randomNumbers(10), 300, ctx));
    }
}
