package com.pj.project.tb_init_permission;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import com.pj.utils.sg.*;
import com.pj.utils.so.*;
import com.pj.project4sp.SP;

import com.pj.current.satoken.StpUserUtil;
import cn.dev33.satoken.annotation.SaCheckPermission;


/**
* Controller: tb_init_permission -- 初始化权限
* @author qzyReal
*/
@RestController
@RequestMapping("/TbInitPermission/")
public class TbInitPermissionController {

/** 底层 Service 对象 */
@Autowired
TbInitPermissionService tbInitPermissionService;

/** 增 */
@RequestMapping("add")
	@SaCheckPermission(TbInitPermission.PERMISSION_CODE)
@Transactional(rollbackFor = Exception.class)
public AjaxJson add(TbInitPermission t){
tbInitPermissionService.add(t);
return AjaxJson.getSuccessData(t);
}

/** 删 */
@RequestMapping("delete")
	@SaCheckPermission(TbInitPermission.PERMISSION_CODE)
public AjaxJson delete(Long id){
tbInitPermissionService.delete(id);
return AjaxJson.getSuccess();
}

/** 删 - 根据id列表 */
@RequestMapping("deleteByIds")
	@SaCheckPermission(TbInitPermission.PERMISSION_CODE)
public AjaxJson deleteByIds(){
List<Long> ids = SoMap.getRequestSoMap().getListByComma("ids", long.class);
	int line = SP.publicMapper.deleteByIds(TbInitPermission.TABLE_NAME, ids);
	return AjaxJson.getByLine(line);
	}

	/** 改 */
	@RequestMapping("update")
		@SaCheckPermission(TbInitPermission.PERMISSION_CODE)
	public AjaxJson update(TbInitPermission t){
		tbInitPermissionService.update(t);
	return AjaxJson.getSuccess();
	}

	/** 查 - 根据id */
	@RequestMapping("getById")
	public AjaxJson getById(Long id){
	TbInitPermission t = tbInitPermissionService.getById(id);
	return AjaxJson.getSuccessData(t);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */
	@RequestMapping("getList")
	public AjaxJson getList() {
	SoMap so = SoMap.getRequestSoMap();
		List<TbInitPermission> list = tbInitPermissionService.getList(so.startPage());
	return AjaxJson.getPageData(so.getDataCount(), list);
	}










			}
